#include <stdio.h>
#include <string.h>

#define FILENAMELENGTH  20
#define BUFSIZE        512

/* Main
 */
int main(void) {
    char filenameIn[FILENAMELENGTH];
    char filenameOut[FILENAMELENGTH];
    FILE *fpIn;
    FILE *fpOut;
    char buf[BUFSIZE];
    char *cp;
    size_t len;

    printf("Zu konvertierende Datei: ");
    scanf("%s", filenameIn);
    
    fpIn = fopen(filenameIn, "r");
    if (fpIn == NULL) {
        printf("Fehler: Datei %s nicht gefunden!\n", filenameIn);
        return -1;
    }

    printf("Ausgabedatei: ");
    scanf("%s", filenameOut);
    
    fpOut = fopen(filenameOut, "w");
    if (fpOut == NULL) {
        printf("Fehler: Konnte Ausgabedatei %s nicht oeffnen!\n", filenameOut);
        fclose(fpIn);
        return -1;
    }

    // Zeilen lesen
    while (fgets(buf, sizeof buf, fpIn) != NULL) {
        // LF am Ende durch CR LF ersetzen.
        len = strlen(buf);
        
        // doppelten Schraegstrich suchen
        cp = strstr(buf, "//");
        if (cp != NULL) {
            ++cp; // zeigt jetzt auf den zweiten Schraegstrich
            *cp = '*'; // "//" in "/*" umwandeln
            
            // Zeilenende suchen
            cp = strchr(cp, '\n');
            if (cp == NULL) {
                printf("Oh - das sollte nicht passieren: Zeilenende nicht gefunden!\n");
                return -1;
            }
            
            // Zeilenende mit " */" ueberschreiben
            *cp++ = ' ';
            *cp++ = '*';
            *cp   = '/';
            
            // Laenge anpassen: wir haben jetzt 3 Zeichen mehr
            len += 3;
        }
        
        // CR, LF und String-Abschluss
        buf[--len] = '\r';
        buf[++len] = '\n';
        buf[++len] = '\0';
        
        // Zeile schreiben
        fwrite(buf, 1, len, fpOut);
    }

    fclose(fpIn);
    fclose(fpOut);

    return 0;
}
